Foreman - Bug #16547

Fact importing fails with NoMethodError: undefined method first' for nil:NilClass
09/14/2016 04:09 AM - Ohad Levy

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Facts
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: Nightly
Bugzilla link: 1432184 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3879
Description

016-09-14T09:01:10 b740424a [app] [I] Processing by Api::V2::HostsController#facts as JSON
2016-09-14T09:01:10 b740424a [app] [I] Parameters: {"facts"=>"[FILTERED]", "name"=>"hO04.example.
com", "certname"=>"4471ddcd-9051-4299-9819-4d%9a8b400fcc", "apiv"=>"v2", :host=>{"certname"=>"4471d
dcd-9051-4299-9819-4d9a8b400fcc", "name"=>"h04.example.com"}}
2016-09-14T09:01:10 b740424a [app] [I] Import facts for 'hO4.example.com' completed. Added: 0, Upd
ated: 4, Deleted 0 facts
2016-09-14T09:01:10 b740424a [app] [W] Action failed

| NoMethodError: undefined method " first' for nil:NilClass

| /home/foreman/git/foreman/app/models/host/base.rb:178:in "block in set_interfaces'

| /home/foreman/git/foreman/app/models/host/base.rb:177:in "each'

| /home/foreman/git/foreman/app/models/host/base.rb:177:in 'set_interfaces'

| /home/foreman/git/foreman/app/models/host/base.rb:154:in “populate_fields_from facts'

| /home/foreman/git/foreman/app/models/host/managed.rb:464:in ‘populate_fields_from_facts'

| /home/foreman/git/foreman/app/models/host/base.rb:131:in ' import_facts'

| /home/foreman/git/foreman/app/models/host/managed.rb:305:in "import_facts'

| /home/foreman/git/foreman/app/controllers/api/v2/hosts_controller.rb:240:in " facts'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/implicit_render.rb:4:in
“send_action'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/abstract_controller/base.rb:198:in "process_acti
on'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/rendering.rb:10:in "“proc
ess_action'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/abstract_controller/callbacks.rb:20:in “block in
process_action'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:117:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:117:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:555:in “block (2
levels) in compile'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:498:in “block (2
levels) in around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “block (2
levels) in halting'

| /home/foreman/git/foreman/app/controllers/api/v2/base_controller.rb:152:in ‘disable_json_root'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:432:in “block in
make_lambda'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in ‘block in
halting'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:497:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in "block in
around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:505:in “call'
| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:498:in “block (2
levels) in around’

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1ib/active_support/callbacks.rb:313:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “block (2
levels) in halting'

| /home/foreman/gems/gems/rails-observers-0.1.2/1ib/rails/observers/action_controller/caching/swe
eping.rb:73:in "around’'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:455:in “public_se
nd'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:455:in “block in
make_lambda'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “block in
halting'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in ‘block in
around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:505:in ‘call'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1ib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:498:in “block (2
levels) in around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “block (2
levels) in halting'

| /home/foreman/git/foreman/app/controllers/concerns/application_shared.rb:14:in "“set_timezone'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:432:in “block in
make_lambda'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “block in
halting'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in “block in
around'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1lib/active_support/callbacks.rb:505:in ‘call'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1ib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:498:in “block (2
levels) in around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “block (2
levels) in halting'

| /home/foreman/git/foreman/app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:432:in “block in
make_lambda'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in “block in
halting'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:497:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in ‘block in
around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:505:in ‘call'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1ib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:498:in “block (2
levels) in around'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:313:in “block (2
levels) in halting'

| /home/foreman/gems/gems/rails-observers—-0.1.2/1ib/rails/observers/action_controller/caching/swe
eping.rb:73:in “around’'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:455:in “public_se
nd'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:455:in “block in
make_lambda'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:312:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:312:in ‘block in
halting'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:497:in “call'
| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:497:in ‘block in
around'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1lib/active_support/callbacks.rb:505:in ‘call'

| /home/foreman/gems/gems/activesupport—-4.2.7.1/1ib/active_support/callbacks.rb:505:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:92:in '_ run_call
backs__ "
| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:778:in ' _run_proc

ess_action_callbacks'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:81:in "run_callba
cks'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/abstract_controller/callbacks.rb:19:in ‘process_
action'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/rescue.rb:29:in "process
_action'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/instrumentation.rb:32:1in

"block in process_action'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/notifications.rb:164:in “block

in instrument'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/notifications/instrumenter.rb:
20:in “instrument'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/notifications.rb:164:in " instr
ument'’

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/instrumentation.rb:30:1in

‘process_action'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal/params_wrapper.rb:250:1in

‘process_action'

| /home/foreman/gems/gems/activerecord-4.2.7.1/1ib/active_record/railties/controller_runtime.rb:1
8:1in "process_action'

/home/foreman/gems/gems/actionpack-4. .1/1ib/abstract_controller/base.rb:137:in "process'

.1/1lib/action_view/rendering.rb:30:in " process'
.1/1lib/action_controller/metal.rb:196:in “dispatch'
.1/1lib/action_controller/metal/rack_delegation.rb:13:in

/home/foreman/gems/gems/actionview—4.

DN NN
~N J 9

I

|

| /home/foreman/gems/gems/actionpack—-4.
| /home/foreman/gems/gems/actionpack—-4.
“dispatch'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_controller/metal.rb:237:in “block in acti

on'
| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/routing/route_set.rb:74:in “call

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/routing/route_set.rb:74:in “disp
atch'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/routing/route_set.rb:43:in "“serv
el

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/routing/mapper.rb:49:in "serve'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1lib/action_dispatch/journey/router.rb:43:in “block i
n serve'
| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/journey/router.rb:30:in “each'
| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/journey/router.rb:30:in "serve'
| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/routing/route_set.rb:817:in "cal
ll

| /home/foreman/gems/gems/apipie-rails-0.3.6/1lib/apipie/static_dispatcher.rb:65:in “call'

| /home/foreman/gems/gems/apipie-rails-0.3.6/1ib/apipie/extractor/recorder.rb:132:in “call’

| /home/foreman/gems/gems/apipie-rails-0.3.6/1lib/apipie/middleware/checksum_in_headers.rb:27:in
call'

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/etag.rb:24:in “call’

w

| /home/foreman/gems/gems/rack—-1.6.4/1lib/rack/conditionalget.rb:38:in “call'

| /home/foreman/gems/gems/rack-1.6.4/1ib/rack/head.rb:13:in “call’

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/params_parser.rb:27:1
n “call'

| /home/foreman/git/foreman/lib/middleware/catch_json_parse_errors.rb:8:in “call'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1lib/action_dispatch/middleware/flash.rb:260:in “call

| /home/foreman/gems/gems/rack-1.6.4/1ib/rack/session/abstract/id.rb:225:in "context'

| /home/foreman/gems/gems/rack-1.6.4/1ib/rack/session/abstract/id.rb:220:in "call’

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/cookies.rb:560:1in “ca
11"

| /home/foreman/gems/gems/activerecord-4.2.7.1/1ib/active_record/query_cache.rb:36:in ‘call'

| /home/foreman/gems/gems/activerecord-4.2.7.1/1ib/active_record/connection_adapters/abstract/con
nection_pool.rb:653:in “call'
| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/callbacks.rb:29:in b
lock in call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:88:in *__ run_call
backs__ "

| /home/foreman/gems/gems/activesupport-4.2.7.1/1ib/active_support/callbacks.rb:778:in " _run_call
_callbacks'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/callbacks.rb:81:in "run_callba
cks'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/callbacks.rb:27:in "¢
all’

| /home/foreman/gems/gems/actionpack-4.2.7.1/1lib/action_dispatch/middleware/remote_ip.rb:78:in “c
all'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/debug_exceptions.rb:1
7:in “call'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/show_exceptions.rb:30
:in “call!
/home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/rack/logger.rb:38:in “call_app'
/home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/rack/logger.rb:22:in “call'
/home/foreman/gems/gems/quiet_assets-1.1.0/1lib/quiet_assets.rb:27:in ‘call_with_quiet_assets'
/home/foreman/git/foreman/lib/middleware/tagged_logging.rb:18:in “call'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1ib/action_dispatch/middleware/request_id.rb:21:in
call'

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/methodoverride.rb:22:in “call'

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/runtime.rb:18:in “call'

| /home/foreman/gems/gems/activesupport-4.2.7.1/1lib/active_support/cache/strategy/local_cache_mid
dleware.rb:28:in “call'

| /home/foreman/gems/gems/actionpack-4.2.7.1/1lib/action_dispatch/middleware/static.rb:120:in “cal

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/sendfile.rb:113:in “call’

| /home/foreman/gems/gems/secure_headers—-3.4.1/1ib/secure_headers/middleware.rb:12:in ‘call'

| /home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/engine.rb:518:in ‘call'

| /home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/application.rb:165:in “call'

| /home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/railtie.rb:194:in “public_send'

| /home/foreman/gems/gems/railties-4.2.7.1/1ib/rails/railtie.rb:194:in "method_missing'

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/urlmap.rb:66:in ‘block in call'

| /home/foreman/gems/gems/rack-1.6.4/1lib/rack/urlmap.rb:50:in “each’

| /home/foreman/gems/gems/rack-1.6.4/lib/rack/urlmap.rb:50:in “call’

| /root/.gem/gems/passenger-5.0.7/1lib/phusion_passenger/rack/thread_handler_extension.rb:89:in "p
rocess_request'

| /root/.gem/gems/passenger-5.0.7/1lib/phusion_passenger/request_handler/thread_handler.rb:155:in
‘accept_and_process_next_request'

| /root/.gem/gems/passenger-5.0.7/1lib/phusion_passenger/request_handler/thread_handler.rb:110:in
‘main_loop'

| /root/.gem/gems/passenger—-5.0.7/1lib/phusion_passenger/request_handler.rb:414:in “block (3 level
s) in start_threads'

| /root/.gem/gems/passenger-5.0.7/1lib/phusion_passenger/utils.rb:111:in “block in create_thread_a
nd_abort_on_exception'

| /home/foreman/gems/gems/logging—2.1.0/1ib/logging/diagnostic_context.rb:450:in “call'

| /home/foreman/gems/gems/logging—-2.1.0/1ib/logging/diagnostic_context.rb:450:in "block in create
_with_logging_context'
2016-09-14T09:01:10 b740424a [app] [I] Rendered api/v2/errors/standard_error.json.rabl within ap
i/v2/layouts/error_layout (0.8ms)
2016-09-14T09:01:10 b740424a [app] [I] Completed 500 Internal Server Error in 299ms (Views: 1.7ms
| ActiveRecord: 109.5ms)

the facts in question are (output of FACTER_domain=example.com facter --json)

{"domain":"example.com", "architecture":"x86_64", "augeasversion":"1.4.0", "kernel":"Linux", "blockdev
ice_sda_size":500107862016, "blockdevice_sda_vendor":"ATA", "blockdevice_sda_model":"ST500NM0011","b
lockdevices":"sda", "macaddress":"02:42:95:9¢c:45:94","osfamily":"RedHat", "operatingsystem":"RedHat"
,"facterversion":"1.7.6","filesystems":"xfs","fqgdn":"h04.example.com", "hardwareisa":"x86_64", "hard
waremodel" :"x86_64", "hostname" :"h04","id":"root", "interfaces":"br_14703d60d2bb, docker0, eml,em2, 10,
vethO28afe7,veth42ffacc,vethac0daz22,vethd78747b, vethf42b68f,virbr0,virbr0_nic", "ipaddress_br_ 14703
de0d2bb":"172.18.0.1", "macaddress_br_14703d60d2bb":"02:42:95:9¢c:45:94", "netmask_br_14703d60d2bb":"
255.255.0.0", "ipaddress_docker0":"172.17.0.1", "macaddress_docker0":"02:42:68:70:81:52", "netmask_do
cker0":"255.255.0.0", "ipaddress_em1":"10.35.27.135", "macaddress_eml":"84:8£:69:fe:27:05", "netmask_
eml":"255.255.255.192", "macaddress_em2":"84:8f:69:fe:27:06", "ipaddress_1o":"127.0.0.1", "netmask_1lo
":"255.0.0.0", "macaddress_veth028afe7":"4e:8a:2d:01:7f:0f", "macaddress_vethd42ffacc":"8a:ec:65:2e:b
6:f2", "macaddress_vethac0da22":"e2:77:c0:86:dd:7d", "macaddress_vethd78747b":"e6:d1:0c:d4:£9:a9", "m
acaddress_vethf42b68f":"56:79:5d:23:cl:fa", "ipaddress_virbr0":"192.168.122.1", "macaddress_virbr0":
"52:54:00:35:¢c8:71", "netmask_virbr0":"255.255.255.0", "macaddress_virbr0_nic":"52:54:00:35:c8:71","
ipaddress":"172.18.0.1", "kernelmajversion":"3.10", "kernelrelease":"3.10.0-327.18.2.e17.x86_64", "ke
rnelversion":"3.10.0", "boardmanufacturer":"Dell Inc.", "boardproductname":"0TTH1R", "boardserialnumb
er":" .BZ73F5J.CN70163260008X.", "bios_vendor":"Dell Inc.","bios_version":"1.0.21","bios_release_dat
e":"04/26/2012", "manufacturer":"Dell Inc.", "productname":"PowerEdge C6220", "serialnumber":"BZ73F5J
", "uuid":"4C4C4544-005A-3710-8033-C2C04F46354A", "type":"Rack Mount Chassis", "memorysize":"23.35 GB
", "memoryfree":"21.75 GB","swapsize":"11.81 GB", "swapfree":"11.81 GB", "swapsize_mb":"12096.00", "sw
apfree_mb":"12096.00", "memorysize_mb":"23906.50", "memoryfree_mb":"22273.37", "memorytotal":"23.35 G
B", "netmask":"255.255.0.0", "network_br_14703d60d2bb":"172.18.0.0", "network_dockerQ0":"172.17.0.0","
network_eml":"10.35.27.128", "network_10o":"127.0.0.0", "network_virbr0O":"192.168.122.0", "operatingsy
stemmajrelease":"7", "operatingsystemrelease":"7.2", "path":"/root/.gem/bin:/root/.gem/ruby/1.8/bin:
/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/root/bin:/sbin:/usr/sbin:/root/scripts", "physic
alprocessorcount":1, "processorQ":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz", "processorl":"Intel (R)
Xeon (R) CPU E5-2620 0 @ 2.00GHz", "processor2":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz", "process
or3":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz","processord":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.0
0GHz", "processor5":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz", "processor6":"Intel (R) Xeon(R) CPU E
5-2620 0 @ 2.00GHz", "processor7":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz", "processor8":"Intel (R)
Xeon (R) CPU E5-2620 0 @ 2.00GHz", "processor9":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz", "process
orl0":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2.00GHz","processorll":"Intel (R) Xeon(R) CPU E5-2620 0 @ 2

.00GHz", "processorcount":"12", "ps":"ps -ef", "puppetversion":"3.6.2", "rubysitedir":"/usr/local/shar
e/ruby/site_ruby/", "rubyversion":"2.0.0","selinux":"true", "selinux_enforced":"true", "selinux_polic
yversion":"28","selinux_current_mode":"enforcing", "selinux_config_mode":"enforcing", "selinux_confi

g_policy":"unknown", "selinux_mode" :"unknown", "sshrsakey" :"AAAAB3NzaClyc2EAAAADAQABAAABAQDTfHoJ1JJu
J14wwQhGSblWsxaalrThfOrsFyE9f1kwKDoTLYxOng30yUWEMOKOcQuUDSYyBTE8dzf1bP90oVEF1GikfwCTPVcOtcgstYbrEM1hh8
Sgu9xDHmn/20F01h840peeNRtr88TNCPyerS7JPYud9TROBX3moe jyIvOn7FFdNsy6NXgS7mNOTUP+4037SnIOMcBOfGv7mtri
+Z1CDNJXMbENfO8/5kFSHbnhmpt 409bC/MveivYXGx9cdSusGCk jUHum8JkB7diOOualb7bzt1D6eKS61BMNOKultAvgege3ii
UbUGFm/p4Ug3qL5CFcImkT2w40xgrfpOVRZIkKZ", "sshfp_rsa":"SSHFP 1 1 81c7f3baef736£64012b497¢c1192dec7£62
03169\nSSHFP 1 2 4bb72ddd99b362886c5d27df31b1ldd9cd65256ec6f3£82c7f6ebd0ac48e65056", "sshecdsakey":"
AAAAE2VJZHNhLXNoYTItbml zdHAYNTYAAAATIbm] zdHAYNTYAAABRBBBUhN+R JwpOQaJlINZ9rPIRVPRIb3qp3VBQ8s9anlkB4dS
V7/9FQzR+ctm+pz4QQQo6bkkqlw5hI+siKgUqwT5k0=", "sshfp_ecdsa":"SSHFP 3 1 85048bfa64d381b4fl0eb22lacbda’
ae27£65debf\nSSHFP 3 2 b9bdfdl11388cab8298598cf73184e£72d8b91c73b118344d4b10104c10dbd42d", "timezone
":"UTC", "uniqueid":"230a871b", "uptime":"113 days", "uptime_days":113, "uptime_hours":2716, "uptime_se
conds":9778327,"virtual":"physical","is_virtual":"false"}

Related issues:
Related to Foreman - Bug #16073: Changing interfaces on unmanaged hosts leads... Closed 08/11/2016
Has duplicate Foreman - Bug #16583: error during import_facts when get_interf... Duplicate 09/16/2016

Associated revisions

Revision dc212679 - 09/23/2016 09:45 AM - Dominic Cleal

fixes #16547 - handle nil value from get_interface_scope

Since 7b75a6a, get_interface_scope may return no scope for managed hosts
when importing a physical interface not already known by MAC address.

Revision 0a18d150 - 09/26/2016 07:39 AM - Dominic Cleal
fixes #16547 - handle nil value from get_interface_scope
Since 7b75a6a, get_interface_scope may return no scope for managed hosts

when importing a physical interface not already known by MAC address.
(cherry picked from commit dc2126790aeaa0160f7e9ae6f8f86319b9f60e3d)

History

#1 - 09/14/2016 04:23 AM - Dominic Cleal
- Subject changed from fact importing fails to Fact importing fails with NoMethodError: undefined method “first' for nil:NilClass

It would be helpful if you can get more specific information about which interface is failing, and under what circumstances (type of interface, MAC
address behaviour) the get_interface_scope method is returning a nil scope. | can't reproduce this at the moment.

#2 - 09/14/2016 04:33 AM - Ohad Levy

Dominic Cleal wrote:
It would be helpful if you can get more specific information about which interface is failing, and under what circumstances (type of interface, MAC
address behaviour) the get_interface_scope method is returning a nil scope. | can't reproduce this at the moment.

with the following code change:

diff --git a/app/models/host/base.rb b/app/models/host/base.rb
index 419c568..8869%cf 100644
—-—— a/app/models/host/base.rb
+++ b/app/models/host/base.rb
@@ -175,9 +175,14 @Q module Host
end

parser.interfaces.each do |name, attributes|
+ begin
iface = get_interface_scope (name, attributes).first || interface_class (name) .new (:managed => fal
# create or update existing interface
set_interface (attributes, name, iface)

+ rescue => e
+ logger.warn ("Failed to process interface: #{name}/#{iface} - #{attributes}")
+ raise e
+ end
end
the output is:
Failed to process interface: docker0/ - {"ipaddress"=>"172.17.0.1", "macaddress"=>"02:42:68:70:81:52", "netmas

k"=>"255.255.0.0", "network"=>"172.17.0.0", "link"=>"false", "virtual"=>false}

#3 - 09/16/2016 10:13 AM - Dominic Cleal

- Has duplicate Bug #16583: error during import_facts when get_interface_scope() returns nil added

#4 - 09/16/2016 11:33 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Thomas McKay

- Pull request https://github.com/theforeman/foreman/pull/3856 added

#5 - 09/19/2016 05:01 AM - Dominic Cleal
- Related to Bug #16073: Changing interfaces on unmanaged hosts leads to an invalid host added

#6 - 09/19/2016 05:01 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#7 - 09/23/2016 05:21 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/3879 added

#8 - 09/23/2016 10:03 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset dc2126790aeaa0160f7e9ae6f8f86319b9f60e3d.

#9 - 09/23/2016 10:03 AM - Dominic Cleal

- Assignee changed from Thomas McKay to Dominic Cleal

#10 - 03/15/2017 04:27 AM - Tomer Brisker
- Pull request deleted (https://github.com/theforeman/foreman/pull/3856)

#11 - 03/23/2017 10:50 AM - Sean O'Keeffe
- Bugzilla link set to 1432184

05/18/2024 6/6


https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/dc2126790aeaa0160f7e9ae6f8f86319b9f60e3d
http://www.tcpdf.org

